package cn.iocoder.yudao.module.system.service.houselocation;

import java.util.*;
import javax.validation.*;

import cn.iocoder.yudao.module.system.controller.admin.houselocation.vo.WareHouseTakePointPageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.houselocation.vo.WareHouseTakePointSaveReqVO;
import cn.iocoder.yudao.module.system.dal.dataobject.houselocation.WareHouseTakePointDO;
import com.baomidou.mybatisplus.extension.service.IService;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;

/**
 * 取货点位 Service 接口
 *
 * @author 陈宾顺
 */
public interface WareHouseTakePointService extends IService<WareHouseTakePointDO> {

    /**
     * 创建取货点位
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createHouseTakePoint(@Valid WareHouseTakePointSaveReqVO createReqVO);

    /**
     * 更新取货点位
     *
     * @param updateReqVO 更新信息
     */
    void updateHouseTakePoint(@Valid WareHouseTakePointSaveReqVO updateReqVO);

    /**
     * 删除取货点位
     *
     * @param id 编号
     */
    void deleteHouseTakePoint(Long id);

    /**
     * 获得取货点位
     *
     * @param id 编号
     * @return 取货点位
     */
    WareHouseTakePointDO getHouseTakePoint(Long id);

    /**
     * 获得取货点位分页
     *
     * @param pageReqVO 分页查询
     * @return 取货点位分页
     */
    PageResult<WareHouseTakePointDO> getHouseTakePointPage(WareHouseTakePointPageReqVO pageReqVO);

    List<WareHouseTakePointDO> getHouseTakePointList(WareHouseTakePointSaveReqVO updateReqVO);

    void setTakePointMapIdEmpty(Long mapId,List<Long> ids);

    void batchEditOrDel(List<List<WareHouseTakePointDO>> list);

    WareHouseTakePointDO getHouseTakePointByItemIdAndStorey(Long positionMapItemId, int locationStorey);

    void updateHouseTakePointByItemIdAndStorey(WareHouseTakePointDO pointDO);

}
